function [K,id_sing,sing] = cone_curvature(X, T, if_plot)
% Ben-Chen et al. 2008, "Conformal Flattening by Curvature Prescription and Metric Scaling"

mesh = create_mesh(X, T);
phidiff = 1; % Threshold for iterative singularity placement
[id_sing, sing] = find_singularities(mesh, phidiff);
K = zeros(mesh.nv,1);
K(id_sing) = sing;

if abs(sum(sing) - 2*pi*(mesh.nv - mesh.ne + mesh.nf)) > 1e-5
    warning('Broken total curvature.')
end

if exist('if_plot','var') && if_plot
    figure;
    trisurf(T, X(:,1), X(:,2), X(:,3), K, 'facecolor', 'interp', 'edgecolor', 'k');
    axis equal;
    title('Target cone metric');
end