function mesh = MeshInfo(T)

mesh.T = T;
assert(size(T,2) == 3, 'Not a triangulations.');
[mesh.E2V, mesh.T2E, mesh.E2T, mesh.E2T2] = compute_connectivity(mesh.T);

mesh.nf = size(mesh.T,1);
mesh.nv = max(mesh.T(:));
mesh.ne = size(mesh.E2V,1);

% Compute boundary components
if any(mesh.E2T(:) == 0)
    warning('Mesh with boundary! This code is not ready for that yet.');
    mesh.is_bnd = true;
    mesh.ide_bound = any(mesh.E2T == 0, 2);
    mesh.idvx_bound = unique(M.E2V(mesh.ide_bound,:));
else
    mesh.is_bnd = false;
    mesh.ide_bound = [];
    mesh.idvx_bound = [];
end
