function [normal,area,vertex_normal] = compute_normals(X, T)

% Normals and areas
normal = cross(X(T(:,1),:) - X(T(:,2),:), X(T(:,1),:) - X(T(:,3),:));
area = sqrt(sum(normal.^2, 2))/2;
normal = normal./repmat(sqrt(sum(normal.^2, 2)), [1, 3]);

% Vertex normals
vertex_normal = [accumarray(T(:), repmat(normal(:,1).*area, [3,1])), ...
                 accumarray(T(:), repmat(normal(:,2).*area, [3,1])), ...
                 accumarray(T(:), repmat(normal(:,3).*area, [3,1]))];
vertex_normal = vertex_normal./repmat(sqrt(sum(vertex_normal.^2, 2)), [1,3]);