function conf_disto = quasi_conformal_error(T, X0, X1)
nf = size(T,1);

[e1_0,e2_0] = compute_local_basis(X0, T);
[e1_1,e2_1] = compute_local_basis(X1, T);

conf_disto = zeros(nf,1);
for i = 1:nf
    J0 = [e1_0(i,:); e2_0(i,:)]*[X0(T(i,1),:) - X0(T(i,2),:); X0(T(i,1),:) - X0(T(i,3),:)]';
    J1 = [e1_1(i,:); e2_1(i,:)]*[X1(T(i,1),:) - X1(T(i,2),:); X1(T(i,1),:) - X1(T(i,3),:)]';
    Jac = J0/J1;
    
    s = svd(Jac);
    conf_disto(i) = s(1)/s(2);
end
end

function [e1,e2] = compute_local_basis(X, T)
normal = cross(X(T(:,1),:) - X(T(:,2),:), X(T(:,1),:) - X(T(:,3),:), 2);
normal = normal./sqrt(sum(normal.^2,2));

e1 = X(T(:,1),:) - X(T(:,2),:);
e1 = e1./sqrt(sum(e1.^2,2));
e2 = cross(normal, e1, 2);
end