# Curvature-Driven Conformal Deformations

MATLAB implementation of *Curvature-Driven Conformal Deformations* and movies corresponding to the paper's figures.

## Using the Demo Script
Run the script `surface_flow.m` from the folder `Code/`. It should be self contained and no external library should be needed for MATLAB R2023a. The meshes are stored in the `Data/` folder with one folder per mesh. A few options are available:

* `model`: loads the mesh `Data/model/model.obj`.
* `fct_type`: sets the objective function between the three choices:
	 - `'p-norm'` for the p-bending energy;
	 - `'ricci'` for the Ricci flow;
	 - `'p-willmore'` for the p-Willmore energy.
* `opt.p`: sets the power p for the p-bending and p-Willmore energies.
* `opt.Kt`: sets the target angle defect per vertex for the Ricci flow. By default, a cone disctribution is computed using the algorithm (and code) of Ben-Chen et al. 2008, *Conformal Flattening by Curvature Prescription and Metric Scaling*.
* `if_vertex_const`: toggles vertex contraints. By default, the code attempts to load the file `idvx_lock.mat` in the folder `Data/model/`, containing the array `idvx_lock` of fixed vertex indices.
* `if_save`: saves the meshes generated at each iteration in the folder `Data/model/fct_type/`.
* `limit_ang`: step size limitation parameter (in degree) referred to as $$\xi_{\max}$$ in the paper.